//-----------------------------------------------------------------------------
// LOGGER.CPP
// By Dean Harding
// 
// Copyright (c) 2000/2001 Dean Harding
//-----------------------------------------------------------------------------
#include "internal.h"

HANDLE g_hThread = NULL;

//-----------------------------------------------------------------------------
void CLogger::Initialize()
{
	if( g_hThread != NULL )
	{
		// initialize has already been called.
		return;
	}

	DWORD dwThreadId;

	// create the thread that will actually do the logging
	g_hThread = CreateThread( NULL, 0, LoggerWorkerThread, NULL, 0, &dwThreadId );

}

//-----------------------------------------------------------------------------
void CLogger::Shutdown()
{
	if( g_hThread == NULL )
	{
		// Initialize hasn't been called, or Shutdown has already been called.
		return;
	}

	// add a NULL item to the queue.  That the thread's queue to quit.
	g_LoggerQueue.AddItem( NULL );

	WaitForSingleObject( g_hThread, INFINITE );
	CloseHandle( g_hThread );

	g_hThread = NULL;
}

//-----------------------------------------------------------------------------
CLogger *CLogger::Attach( TCHAR *szLogFile )
{
	return new CLoggerImpl( szLogFile );
}

//-----------------------------------------------------------------------------
// End of LOGGER.CPP
//-----------------------------------------------------------------------------
