//-----------------------------------------------------------------------------
// LOGGER_TEST.CPP
// By Dean Harding
// 
// Copyright (c) 2000/2001 Dean Harding
//-----------------------------------------------------------------------------
// This is just a little console application which creates a number of threads
// and writes stuff to the log file.  It's just to test logger.dll
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include "..\logger\logger.h"

//-----------------------------------------------------------------------------
int main( int argc, char **argv )
{
	cout << "Hello World!!" << endl;

	CLogger::Initialize();

	CLogger *logger = CLogger::Attach( _T("log\\errors.log") );
	if( logger == NULL )
	{
		cout << "Could not attack to logger." << endl;
		return 1;
	}

	logger->SetFormat( LOG_PROCNAME | LOG_TIMESTAMP | LOG_THREADID );
	DWORD dwProcessId = GetCurrentProcessId();
	DWORD dwRun = 1;
	while( !kbhit() )
	{
		cout << "Process: " << dwProcessId << ", Run: " << dwRun << endl;
		logger->Print( "Process: %d, Run: %d", dwProcessId, dwRun );
		dwRun ++;

		// make it so the log file doesn't get too big, too fast...
		// if you remove this, then expect a large lot of log files :)
		//Sleep( 100 );
	}

	cout << "Flushing log file..." << endl;
	logger->Release();
	logger = NULL;

	cout << "Finishing logging..." << endl;
	CLogger::Shutdown();

	getch();

	return 0;
}

//-----------------------------------------------------------------------------
// End of LOGGER_TEST.CPP
//-----------------------------------------------------------------------------
